library DemoDLL;

{ Wichtiger Hinweis zur DLL-Speicherverwaltung: ShareMem mu sich in der
	ersten Unit der unit-Klausel der Bibliothek und des Projekts befinden (Projekt-
	Quelltext anzeigen), falls die DLL Prozeduren oder Funktionen exportiert, die
	Strings als Parameter oder Funktionsergebnisse weitergibt. Dies trifft auf alle
	Strings zu, die von oder zur DLL weitergegeben werden -- auch diejenigen, die
	sich in Records oder Klassen befinden. ShareMem ist die Schnittstellen-Unit
	zu BORLNDMM.DLL, der gemeinsamen Speicherverwaltung, die zusammen mit
	der DLL weitergegeben werden mu. Um die Verwendung von BORLNDMM.DLL
	zu vermeiden, sollten String-Informationen als PChar oder ShortString bergeben werden. }

uses
  SysUtils,
  Classes,
	windows,
	forms,
	IB_Components,
  ib_header,
  dmodul in 'dmodul.pas' {dm: TDataModule},
  viewData in 'viewData.pas' {FormViewData};

{$R *.RES}

var
	SaveExit          : Pointer;

procedure LibExit;
begin
	ExitProc := SaveExit;  // restore exit procedure chain
end;

function VersionString: ShortString;
begin
	Result := 'DLL Version 1';
end;

function VersionInteger: Integer;
begin
	Result := 1;
end;

function ViewData
	(
		const ibcHandle			: isc_db_handle;	// HANDLE IB_CONNECTION
		var  	PWndHandle 		: HWND;						// Handle Window
		var 	errorMessage	: ShortString;		// for error messages
		const searchValue		: PChar;					// for error messages
		const searchField		: Integer					// which function to execute
	): Boolean; stdcall;
var
	aViewForm	: TFormViewData;
	LabelText	: String;
begin
	// try to connect the db
	errorMessage := '';
	try
		dm.ibc.dbHandleShared	:= ibcHandle;
		Result := dm.ibc.Connected;
	except
		errorMessage := 'Connection handle could not be assigned';
	end;

	if Result then
	begin

		dm.qrySessions.SQLWhere.Clear;

		if searchValue <> '' then
		begin
			case searchField of
				0	: begin
							dm.qrySessions.SQLWhere.Add ( 'WHERE SESSION_TOPIC CONTAINING ' +
																						QuotedStr ( searchValue ) );
							LabelText := 'Searching for session <' + searchValue + '>';
						end;
				1	: begin
							dm.qrySessions.SQLWhere.Add ( 'WHERE S1.SPEAKER_NAME CONTAINING ' +
																					QuotedStr ( searchValue ) + ' OR ' +
																					'S2.SPEAKER_NAME CONTAINING ' +
																					QuotedStr ( searchValue ) );
							LabelText := 'Searching for speaker <' + searchValue + '>';
						end;
				2	: begin
							dm.qrySessions.SQLWhere.Add ( 'WHERE R.ROOM_NAME = ' +
																					QuotedStr ( searchValue ) );
							LabelText := 'Searching for Room <' + searchValue + '>';
						end;
				3	: begin
							dm.qrySessions.SQLWhere.Add ( 'WHERE S.SESSION_DATE = ' +
																					QuotedStr ( searchValue ) );
							LabelText := 'Searching for date <' + searchValue + '>';
						end;
			end;
		end
		else LabelText := 'No search criteria applied';

		try
			dm.qrySessions.Prepare;
			dm.qrySessions.Open;

			if PWndHandle = 0 then PWndHandle := GetActiveWindow;
			Application.Handle := PWndHandle;

			FormViewData := TFormViewData.Create ( NIL );
			try
				FormViewData.pnlTop.Caption := LabelText;
				FormViewData.ShowModal;
			finally
				FreeAndNil ( FormViewData );
			end;
		except
			errorMessage := 'Error creating SQL';
			Result := FALSE;
		end;
		dm.qrySessions.Close;
	end
	else errorMessage := 'Handle of an inactive connection passed';
end;

function UnloadDemoDLL: Boolean;
begin
	dm.Free;
	dm := NIL;
end;

exports VersionString				Resident;
exports VersionInteger			Resident;
exports ViewData						Resident;
exports UnloadDemoDLL				Resident;


// ALLGEMEINER CODE ZUR AUSFHRUNG BEIM LADEN ....

begin
	SaveExit := ExitProc;  // save exit procedure chain
	ExitProc := @LibExit;  // install LibExit exit procedure

	// library initialization code
	dm			 := Tdm.Create ( nil );
end.
