unit mainDemo;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	IB_Components, IB_Session, StdCtrls, ExtCtrls, ComCtrls, Buttons, FileCtrl,
	Grids, IB_Grid, IB_Header, IB_Controls {for shared handle!};

type TViewData = function
	(
		const ibcHandle			: isc_db_handle;	// HANDLE IB_CONNECTION
		var  	PWndHandle 		: HWND;						// Handle Window
		var 	errorMessage	: ShortString;		// for error messages
		const searchValue		: PChar;					// serach value
		const searchField		: Integer					// which function to execute
	): Boolean; stdcall;

type TUnloadDLL = function: Boolean; stdcall;

type
	TMainFormDemoEmbedded = class(TForm)
		ibc: TIB_Connection;
    taRead: TIB_Transaction;
		pc1: TPageControl;
		ts1: TTabSheet;
    ts2: TTabSheet;
    ts3: TTabSheet;
		Panel1: TPanel;
		btnLookupDB: TSpeedButton;
		Panel2: TPanel;
		Label2: TLabel;
    pnlConnStatus1: TPanel;
		OpenDialog1: TOpenDialog;
		btnClose: TBitBtn;
    qrySessions: TIB_Query;
    dsSessions: TIB_DataSource;
    ibc2: TIB_Connection;
    ts4: TTabSheet;
    Panel3: TPanel;
    Label6: TLabel;
    btnConnection2: TBitBtn;
    Panel4: TPanel;
    Panel5: TPanel;
    gridSpeakers: TIB_Grid;
    qrySpeakers: TIB_Query;
    dsSpeakers: TIB_DataSource;
    taConn2: TIB_Transaction;
    Panel6: TPanel;
    Panel7: TPanel;
    GridSpeakerSessions: TIB_Grid;
    dsSpeakerSession: TIB_DataSource;
    pnlBrowse: TPanel;
    Panel9: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    btnSysdba: TSpeedButton;
    btnDummyUser: TSpeedButton;
    btnEmpty: TSpeedButton;
    EditDB: TEdit;
    EditUser: TEdit;
    EditPass: TEdit;
    btnConnect: TBitBtn;
    pnlTitel: TPanel;
    qrySpeakerSession: TIB_Query;
		btnDummy: TSpeedButton;
    Panel8: TPanel;
    Label8: TLabel;
    IB_Text1: TIB_Text;
    Label11: TLabel;
    IB_Text2: TIB_Text;
    Label12: TLabel;
    IB_Text3: TIB_Text;
    IB_Text4: TIB_Text;
    Label13: TLabel;
    IB_Text5: TIB_Text;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Panel10: TPanel;
    btnCallDLL: TBitBtn;
    Label17: TLabel;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    rgDLLView: TRadioGroup;
    gridSessions: TIB_Grid;
    Panel11: TPanel;
    EditSearchSe: TEdit;
    EditSearchSp: TEdit;
    comboRoom: TComboBox;
    comboDay: TComboBox;
    btnAppPath: TSpeedButton;
    btnAppPathDB: TSpeedButton;
    Panel12: TPanel;
    Image1: TImage;
    Panel13: TPanel;
    Label9: TLabel;
    Panel14: TPanel;
    Label18: TLabel;
    pnlConnStatus2: TPanel;
    cboxServer: TCheckBox;
    editServer: TEdit;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    lbServerVersion: TLabel;
		lbImplementation: TLabel;
		Label19: TLabel;
		cboxUserServer2: TCheckBox;
    cboxRemote1: TCheckBox;
    cboxRemote2: TCheckBox;
    Label10: TLabel;
    lbServerName: TLabel;
    cboxHandle2: TCheckBox;
    cboxUseCharSet: TCheckBox;
		procedure FormCreate(Sender: TObject);
		procedure pc1Changing(Sender: TObject; var AllowChange: Boolean);
		procedure ibcAfterConnect(Sender: TIB_Connection);
		procedure btnLookupDBClick(Sender: TObject);
		procedure btnConnectClick(Sender: TObject);
		procedure btnSysdbaClick(Sender: TObject);
		procedure btnConnection2Click(Sender: TObject);
		procedure btnCallDLLClick(Sender: TObject);
		procedure FormDestroy(Sender: TObject);
		procedure dsSpeakersDataChange(Sender: TIB_StatementLink;
			Statement: TIB_Statement; Field: TIB_Column);
		procedure ibc2AfterConnect(Sender: TIB_Connection);
		procedure btnAppPathClick(Sender: TObject);
		procedure cboxServerClick(Sender: TObject);
		procedure btnCloseClick(Sender: TObject);
	private
		{ Private-Deklarationen }
		DemoDLLHandle: THandle;
		function DoConnectDatabase: Boolean;
		function UnloadDemoDLL: Boolean;
		function LoadDemoDLL: Boolean;
	public
		{ Public-Deklarationen }
	end;

var
	MainFormDemoEmbedded: TMainFormDemoEmbedded;

implementation

{$R *.DFM}

procedure TMainFormDemoEmbedded.FormCreate(Sender: TObject);
begin
	btnAppPath.Click;
	OpenDialog1.InitialDir := ExtractFilePath ( Application.ExeName );
	EditUser.Text := 'SYSDBA';
	EditPass.Text := 'masterkey';
	pc1.ActivePage := ts1;         
	ibcAfterConnect ( NIL );
	SetCurrentDir ( ExtractFilePath ( Application.ExeName ) );

	comboRoom.ItemIndex := 0;
	comboDay.ItemIndex := 0;
end;

procedure TMainFormDemoEmbedded.FormDestroy(Sender: TObject);
begin
	UnloadDemoDLL;
	ibc.Disconnect;
end;

procedure TMainFormDemoEmbedded.pc1Changing(Sender: TObject; var AllowChange: Boolean);
begin
	// AllowChange := ibc.Connected;
end;

procedure TMainFormDemoEmbedded.ibcAfterConnect(Sender: TIB_Connection);
begin
	if ibc.Connected then
	begin
		pnlConnStatus1.Color 			:= clLime;
		pnlConnStatus1.Caption 		:= 'CONNECTED';
		btnConnect.Caption 				:= 'DISCONNECT';
		lbServerVersion.Caption 	:= ibc.Characteristics.dbVersion;
		lbImplementation.Caption 	:= IntToStr ( ibc.Characteristics.dbImplementationPrefix ) + '.' +
																 IntToStr ( ibc.Characteristics.dbImplementation );
		lbServerName.Caption			:= ibc.Server;
		with qrySessions do
		begin
			try
				if not Prepared then Prepare;
				Open;
			except
				on E: Exception do
				begin
					MessageDlg ( 'Connection ok, but the following error occured' + #13 + #10 + #13 + #10 +
											 E.Message, mtError, [mbOK], 0 )	;
				end;
			end;
		end;
	end
	else begin
		lbServerVersion.Caption 	:= 'n.a.';
		lbImplementation.Caption 	:= 'n.a.';
		lbServerName.Caption			:= 'n.a.';
		pnlConnStatus1.Color 		:= clRed;
		pnlConnStatus1.Caption 	:= 'NOT CONNECTED';
		btnConnect.Caption 			:= 'CONNECT';
		pc1.ActivePage 					:= ts1;
		ibc2.Connected					:= FALSE;
	end;
	btnAppPath.Enabled		:= NOT ibc.Connected;
	btnAppPathDB.Enabled	:= NOT ibc.Connected;
	btnSysdba.Enabled 		:= NOT ibc.Connected;
	btnDummyUser.Enabled 	:= NOT ibc.Connected;
	btnDummy.Enabled 			:= NOT ibc.Connected;
	btnEmpty.Enabled 			:= NOT ibc.Connected;
	EditUser.Enabled			:= NOT ibc.Connected;
	EditPass.Enabled			:= NOT ibc.Connected;
	cboxServer.Enabled		:= NOT ibc.Connected;
	editServer.Enabled		:= NOT ibc.Connected;
	gridSessions.Visible	:= ibc.Connected;

	cboxRemote1.Checked := ibc.Connected AND ( ibc.Protocol = cpTCP_IP );
end;

procedure TMainFormDemoEmbedded.ibc2AfterConnect(Sender: TIB_Connection);
begin
	if ibc2.Connected then
	begin
		pnlConnStatus2.Color 		:= clLime;
		pnlConnStatus2.Caption 	:= 'CONNECTED';
		btnConnection2.Caption 	:= 'Close second connection';
	end
	else begin
		pnlConnStatus2.Color 		:= clRed;
		pnlConnStatus2.Caption 	:= 'NOT CONNECTED';
		btnConnection2.Caption 	:= 'Open a second connection from this program';
	end;
	cboxRemote2.Checked := ibc2.Connected AND ( ibc2.Protocol = cpTCP_IP );
end;

procedure TMainFormDemoEmbedded.btnLookupDBClick(Sender: TObject);
begin
	if OpenDialog1.Execute then
	begin
		if ibc.Connected AND ( OpenDialog1.FileName <> EditDB.Text ) then
		begin
			ibc.Disconnect;
			EditDB.Text := OpenDialog1.FileName;
			DoConnectDatabase;
		end;
	end;
end;

function TMainFormDemoEmbedded.DoConnectDatabase: Boolean;
begin
	// Connect to Database
	with ibc do
	begin
		try
			if Connected then Disconnect;
			if cboxServer.Checked AND ( editServer.Text <> '' ) then
			begin
				Protocol 	:= cpTCP_IP;
				Server 		:= editServer.Text;
			end
			else begin
				Protocol := cpLocal;
				Server   := '';
			end;
			Username := EditUser.Text;// 'SYSDBA';
			Password := EditPass.Text; // 'masterkey';
			Path 		 := EditDB.Text;

			if cboxUseCharSet.Checked
				then CharSet := 'WIN1252'
				else CharSet := 'NONE';

			Connect;
			Result := TRUE;

			// show connection info...
		except
			Result := FALSE;
			raise;
		end;
	end;
end;

procedure TMainFormDemoEmbedded.btnConnectClick(Sender: TObject);
begin
	if ibc.Connected
		then ibc.Disconnect
		else DoConnectDatabase;
end;

procedure TMainFormDemoEmbedded.btnSysdbaClick(Sender: TObject);
begin
	if Sender = btnSysdba then
	begin
		EditUser.Text := 'SYSDBA';
		EditPass.Text := 'masterkey';
	end
	else if Sender = btnDummyUser then
	begin
		EditUser.Text := 'DUMMYUSER';
		EditPass.Text := 'dunno';
	end
	else if Sender = btnDummy then
	begin
		EditUser.Text := 'DUMMYU';
		EditPass.Text := 'another dunno';
	end
	else begin
		EditUser.Text := '';
		EditPass.Text := '';
	end;
end;

procedure TMainFormDemoEmbedded.btnConnection2Click(Sender: TObject);
begin
	with ibc2 do
	begin
		try
			if Connected then Disconnect
			else begin
				Path 			:= ibc.Path;
				Username 	:= ibc.Username;
				Password	:= ibc.Password;

				if cboxUserServer2.Checked then
				begin
					Protocol 	:= ibc.Protocol;
					Server 		:= ibc.Server;
				end
				else begin
					Protocol := cpLocal;
					Server   := '';
				end;
				CharSet := ibc.CharSet;
				
				Connect;

				qrySpeakers.Prepare;
				qrySpeakers.Open;
			end;
		except
			raise;
		end;
	end;
end;

procedure TMainFormDemoEmbedded.btnCallDLLClick(Sender: TObject);
var
	errMess		: ShortString;
	sValue		: PChar;
	DLLProc  	: TViewData;
	procName	: String;
	pWndHandle: HWnd;
	aConn			: TIB_Connection;
begin

	if cboxHandle2.Checked
		then aConn := ibc2
		else aConn := ibc;

	if aConn.dbHandle = NIL then
	begin
		MessageDlg( 'The connection has no dbHandle ', mtError, [mbOK], 0);
		exit;
	end;

	if NOT LoadDemoDLL then
	begin
		MessageDlg( 'DemoDLL could not be loaded', mtError, [mbOK], 0);
		exit;
	end;

	procName 		:= 'ViewData';
	@DLLProc 		:= GetProcAddress ( DemoDLLHandle, PChar ( procName ) );
	pWndHandle 	:= Screen.ActiveForm.Handle;

	if @DLLProc <> nil then
	begin

		errMess := '';
		case rgDLLView.ItemIndex of
			0	: sValue 	:= PChar ( EditSearchSe.Text );
			1	: sValue 	:= PChar ( EditSearchSp.Text );
			2	: sValue 	:= PChar ( comboRoom.Text );
			3	: case comboDay.ItemIndex of
						0 : sValue := '13.11.2005';
						1 : sValue := '14.11.2005';
						2 : sValue := '15.11.2005';
					end;
		end;

		try
			if NOT DLLProc ( 	aConn.dbHandle,				// HANDLE OF THE CONNECTION
												pWndHandle,					// HANDLE OF ACTIVE WINDOW
												errMess,						// VAR: will hold Errors returned by DLL
												sValue,							// SearchValue
												rgDLLView.ItemIndex // Which Data to View
										 )
				then MessageDlg ( 'Error returned by DLL:' + #13 + #10 + errMess, mtError, [mbOK], 0 );
		finally
			UnloadDemoDLL;
		end;
	end;
end;


function TMainFormDemoEmbedded.UnloadDemoDLL: Boolean;
begin
	// Unload the library, reset the handle
	if DemoDLLHandle > 0 then
	begin
		FreeLibrary ( DemoDLLHandle );
		DemoDLLHandle 	:= 0;
	end;
end;

function TMainFormDemoEmbedded.LoadDemoDLL: Boolean;
const
	DLLName = 'DemoDLL';
begin
	// Load the dll
	if DemoDLLHandle = 0 then
	begin
		try
			DemoDLLHandle :=
					LoadLibrary ( PChar ( IncludeTrailingBackslash (
																ExtractFilePath ( Application.ExeName ) ) +
																DLLName ) );
		finally
		end;
	end;
	Result := DemoDLLHandle > 0;
end;

procedure TMainFormDemoEmbedded.dsSpeakersDataChange(Sender: TIB_StatementLink;
	Statement: TIB_Statement; Field: TIB_Column);
begin
	// view the sessions the speaker is in
	if Field = NIL then
	begin
		with qrySpeakerSession do
		begin
			if not Prepared then Prepare;
			ParamByName ( 'SPEAKER_ID' ).AsInteger 	:= qrySpeakers.FieldByName ( 'SPEAKER_ID' ).AsInteger;
			ParamByName ( 'SPEAKER_ID2' ).AsInteger := qrySpeakers.FieldByName ( 'SPEAKER_ID' ).AsInteger;
			Open;
		end;
	end;
end;

procedure TMainFormDemoEmbedded.btnAppPathClick(Sender: TObject);
begin
	EditDB.Text := IncludeTrailingBackslash ( ExtractFilePath ( Application.ExeName ) );
	if Sender = btnAppPathDB then EditDB.Text := EditDB.Text + 'DB\';
	EditDB.Text := EditDB.Text + 'EMB_DEMO.FDB';
end;

procedure TMainFormDemoEmbedded.cboxServerClick(Sender: TObject);
begin
	if cboxServer.Checked
		then editServer.Color := clWhite
		else editServer.Color := clBtnFace;
end;

procedure TMainFormDemoEmbedded.btnCloseClick(Sender: TObject);
begin
	Close;
end;

end.


